/*******************************************************************************

 Programmed by SEUNG-JO BAE(7/23/93)

 < MIMD Wolff Cluster Algorithm >

 - Single Ant, Version 1.0

 ******************************************************************************/

#include <cm/cmmd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global1.h"
#include "function1.h"


/******************************************************************************
 *                                                                            *
 *  Global variables for the function "communication " and,                   *
 *  Handler Functions used in the function "communication"                    *
 *                                                                            *
 ******************************************************************************/



int send_lsize,    
    send_rsize,    
    recv_lsize,    
    recv_rsize;    


int send_lbyte,
    send_rbyte,
    recv_lbyte,
    recv_rbyte;

Boolean recv_lsize_ack,   
        recv_rsize_ack,   
        recv_lB_ack   ,   
        recv_rB_ack   ;   



void recv_lsize_handler(address, value)  
     int *address;
     int value;
{
   *address = value;
   recv_lsize_ack = true;    
};


void recv_lB_handler()                  
{
   void process_recv_lB();

   recv_lB_ack = true; 
/*   process_recv_lB(); */

};


void recv_rsize_handler(address, value)  
     int *address;
     int value;
{
   *address = value;
   recv_rsize_ack = true; 
};


void recv_rB_handler()                 
{
   void process_recv_rB();

   recv_rB_ack = true; 
/*   process_recv_rB(); */

};


void send_lB_handler(size)
     int *size;
{

 };



void send_rB_handler(size)
     int *size;
{

 };



/******************************************************************************/

void   process_recv_rB()
{
   Remote_cell c;
   Cell son;

   set_ptrB(&recv_rB, recv_rsize-1);

   while ( !emptyB(&recv_rB) ) {
      c = getB(&recv_rB);
      if ( ( ! cluster[c.row][c.col] ) &&
           ( -c.spin == spin[c.row][c.col] ) &&
           ( drandom() < p ) ) {
          cluster[c.row][c.col] = true;
          ++size;
          spin[c.row][c.col] = - spin[c.row][c.col]; 
          son.row = c.row;
          son.col = c.col;
          enQ(&expnQ, son);
          ++ new_counter;
	};
    };      

 };

/******************************************************************************/

void   process_recv_lB()
{
   Remote_cell c;
   Cell son;

   set_ptrB(&recv_lB, recv_lsize-1);

   while ( !emptyB(&recv_lB) ) {
      c = getB(&recv_lB);
      if ( ( ! cluster[c.row][c.col] ) &&
           ( -c.spin == spin[c.row][c.col] ) &&
           ( drandom() < p ) ) {
          cluster[c.row][c.col] = true;
          ++size;
          spin[c.row][c.col] = - spin[c.row][c.col]; 
          son.row = c.row;
          son.col = c.col;
          enQ(&expnQ, son);
          ++ new_counter;
	};
    };      

 };



/******************************************************************************
 *                                                                            *
 *  Function : initialize()                                                   *
 *                                                                            *
 ******************************************************************************/


void initialize()
{
   Boolean error;
   int start, i, j;

   CMMD_disable_safety();
   CMMD_fset_io_mode(stdin, CMMD_sync_bc);
   CMMD_fset_io_mode(stdout, CMMD_sync_bc);
   CMMD_fset_io_mode(stderr, CMMD_independent);

   /*=====================   Read input data  ================================*/

   do {
      printf("\nEnter domain size(Max=%d): ", Nmax);
      scanf("%d", &N);
      error = ( !Log2(N) || N<1 || N>Nmax );
      if (error)
	 printf("\n??? Improper input. Try again!\n");
    } while (error);

   ori_nproc = CMMD_partition_size();
   do {
      printf("\nEnter number of processors(Max=%d): ", ori_nproc);
      scanf("%d", &nproc);
      error = ( !Log2(nproc) || nproc<2 || nproc>ori_nproc || nproc>N );
      if (error)
	 printf("\n??? Improper input. Try again!\n");
    } while (error);
    i = CMMD_reset_partition_size(nproc);
    if (i != nproc) 
       CMMD_error("\nERROR: CMMD Partition failed!\n");
 
   do {
      printf("\nEnter width of a partition(Max=%d): ", N/nproc);
      scanf("%d", &width);
      error = ( !Log2(width) || width<1 || width>N/nproc );
      if (error)
	 printf("\n??? Improper input. Try again!\n");
    } while (error);

   printf("\nEnter the number of thermalization sweeps: ");
   scanf("%d", &therm_sweeps);

   printf("\nEnter number of sweeps per measurements:");
   scanf("%d", &sweeps);

   printf("\nEnter number of measurements:");
   scanf("%d", &measurements);

   printf("\nEnter Beta value:");
   scanf("%lf", &beta);

   printf("\nEnter control of initial state(0=ordered, otherwise random):");
   scanf("%d", &start);

   do {
      printf("\nEnter seed number: ");
      scanf("%d", &seed);
      error = ( seed<0 );
      if (error)
	 printf("\n??? Improper input. Try again!\n");
    } while (error);



   CMAML_disable_interrupts();

   if ( CMAML_allocate_this_rport(rport) <= 0 )
      CMMD_error("ERROR: Failed to allocate receive rport %d\n", rport);

   if ( CMAML_allocate_this_rport(lport) <= 0 )
      CMMD_error("ERROR: Failed to allocate receive rport %d\n", lport);

   CMAML_set_rport_addr         (rport, recv_rB.data);
   CMAML_set_rport_handler      (rport, recv_rB_handler);
   CMAML_set_rport_handler_arg2 (rport, null);

   CMAML_set_rport_addr          (lport, recv_lB.data);
   CMAML_set_rport_handler       (lport, recv_lB_handler);
   CMAML_set_rport_handler_arg2  (lport, null);

   pnum = CMMD_self_address();      
   lpnum = ( pnum==0 )         ? nproc-1 : pnum-1;
   rpnum = ( pnum == nproc-1 ) ? 0       : pnum+1;

   twidth = width * nproc;
   ntile  = N / twidth;

   Nrow   = N;
   Ncol   = width * ntile;

   srandom( seed + pnum );   
                             
   if ( ! start )
      for (i=0; i<Nrow; ++i)
        for (j=0; j<Ncol; ++j) 
	   spin[i][j] = 1;
   else 
      for (i=0; i<Nrow; ++i)
        for (j=0; j<Ncol; ++j) 
	   if ( drandom() > 0.5 )
              spin[i][j] = -1;
           else
              spin[i][j] = 1;
         
   p = 1. - exp( -2. * beta );

   sum_energy = 0.0;
   sum_spins  = 0.0;
   sum_enersq = 0.0;
   sum_spinsq = 0.0;
   sum_size   = 0.0;
   sum_sizesq = 0.0;
   vol        = (double) (N*N);

   CMMD_fset_io_mode(stdout, CMMD_sync_bc);
   printf("\n\n*************************************************");
   printf("\n                  INPUT DATA  ");
   printf("\n*************************************************\n");
   printf("\n Domain size               = %d x %d = %d", N, N, N*N);
   printf("\n Number of processors      = %d", nproc);
   printf("\n Width of each partition   = %d", width);
   printf("\n Height of each partition  = %d", N);
   printf("\n Number of tiles           = %d", ntile);
   printf("\n Width of each title       = %d", twidth);
   printf("\n Local domain size         = %d x %d = %d", Nrow, Ncol, Nrow*Ncol);
   printf("\n");
   printf("\n Thermalization sweeps     = %d", therm_sweeps);
   printf("\n Sweeps per measurements   = %d", sweeps);
   printf("\n Number of measurments     = %d", measurements);
   printf("\n Beta value                = %9.7f", beta);
   printf("\n Wolff probability         = %9.7f", p);
   printf("\n Starting state            = %d", start);
   printf("\n Random seed               = %d\n", seed);
   printf("\n*************************************************\n");


 };

	    

   
/******************************************************************************
 *                                                                            *
 *  Function : measure()                                                      *
 *                                                                            *
 ******************************************************************************/



void measure()
{      
   int sum_sp, sum_ene;
   double ene, mag;
   int i,j,k;

   int* inbuf;
   int* outbuf;
   int length;

   length = intsize*Nrow*ntile;
   inbuf  = (int *)malloc(length);
   outbuf = (int *)malloc(length);

   k = 0;
   if ( pnum > 0 )
      for (j=0; j<ntile; ++j)
         for (i=0; i<Nrow; ++i)
            outbuf[k++] = spin[i][j*width];

   else { 
      for (j=1; j<ntile; ++j)
         for (i=0; i<Nrow; ++i)
            outbuf[k++] = spin[i][j*width];
      for (i=0; i<Nrow; ++i)
         outbuf[k++] = spin[i][0];
    }

   CMMD_send_and_receive(  
                           rpnum,
                           TAG,
                           inbuf,
                           length,
                          
                           lpnum, 
                           TAG, 
                           outbuf, 
                           length);

   sum_ene = 0;

   for (j=0; j<Ncol; ++j)

      if ( ! rbound(j) ) {
         for (i=0; i<Nrow-1; ++i)
            sum_ene += -spin[i][j] * ( spin[i][j+1] + spin[i+1][j] );
         sum_ene +=  -spin[Nrow-1][j] * ( spin[Nrow-1][j+1] + spin[0][j] );
       }

      else { 
         tnum = j / width;
         for (i=0; i<Nrow-1; ++i)
            sum_ene += -spin[i][j] * ( inbuf[i+tnum*Nrow] + spin[i+1][j] );
         sum_ene += -spin[Nrow-1][j] * ( inbuf[Nrow-1+tnum*Nrow] + spin[0][j] );
       }

   sum_ene =  CMMD_reduce_int(sum_ene, CMMD_combiner_add);
   ene = (double)sum_ene / vol;
   sum_energy += ene;
   sum_enersq += (ene * ene);

   sum_sp = 0;
   for (i=0; i<Nrow; ++i)
      for (j=0; j<Ncol; ++j)
          sum_sp += spin[i][j];

   sum_sp = CMMD_reduce_int(sum_sp, CMMD_combiner_add);
   mag = (double)sum_sp / vol;
   if (mag < 0.0)
      mag = -mag;

   sum_spins  += mag;
   sum_spinsq += (mag * mag);

   free(inbuf);
   free(outbuf);
}




/******************************************************************************
 *                                                                            *
 *  Function : output_of_measure()                                            *
 *     Take averages, find errors and variances, and print Out the results.   *
 *                                                                            *
 ******************************************************************************/


void output_of_measure()     
{
   double  specific_heat, susceptibility,
           err_ener, err_spin, err_size, var_size;

   double measure;

   measure = measurements * (double)sweeps;

   /*========================  Take averages ================================*/
   sum_energy = sum_energy / measurements;
   sum_enersq = sum_enersq / measurements;
   sum_spins  = sum_spins  / measurements;
   sum_spinsq = sum_spinsq / measurements;
   sum_size   = sum_size   / measure;
   sum_sizesq = sum_sizesq / measure;

   /*================  Work out errors and variances.  ======================*/
   specific_heat  = sum_enersq - (sum_energy * sum_energy);
   susceptibility = sum_spinsq - (sum_spins  * sum_spins);
   var_size       = sum_sizesq - (sum_size   * sum_size);
   err_ener       = sqrt( abs(specific_heat  / measurements ));
   err_spin       = sqrt( abs(susceptibility / measurements ));
   err_size       = sqrt( abs(var_size       / measure ));
   specific_heat  = specific_heat  * vol;
   susceptibility = susceptibility * vol;

   /*====================  Print out results.  =============================*/
   CMMD_fset_io_mode(stdout, CMMD_sync_bc);
   printf("\n\n*************************************************");
   printf("\n         Statistics(Measurements=%d)", measurements);
   printf("\n*************************************************\n\n");
   printf(" Average energy = %.5f +/- %.5f\n", sum_energy, err_ener );
   printf(" Average magnet = %.5f +/- %.5f\n", sum_spins,  err_spin );
   printf(" Specific heat  = %.5f\n"       , specific_heat        );
   printf(" Susceptibility = %.5f\n"       , susceptibility       );
   printf(" Average size   = %.5f +/- %.5f\n", sum_size, err_size );
   printf("\n*************************************************\n");
  
 }




/******************************************************************************
 *                                                                            *
 *  Function : set_up()                                                       *
 *  Task     : Choose a source cell and destination cell generating random    *
 *             numbers. All processors use same random seed.                  *
 *                                                                            *
 ******************************************************************************/


void set_up()
{  
   int buf[2];
   int i,j;

   if ( pnum == 0 ) {
      buf[0] = irandom();
      buf[1] = irandom();
      CMMD_bc_to_nodes(buf, 8);
    }
   else 
      CMMD_receive_bc_from_node(buf, 8);

   printf("\n Integer Random number  = %d", buf[0]);
   printf("\n Integer Random number  = %d \n", buf[1]);



   source.row = buf[0];
   source.col = buf[1];
   
   source_pnum = (source.col % twidth) / width;
   source_tnum = source.col / twidth;

   source_local.row  = source.row;
   source_local.col  = (source.col % twidth) % width + width * source_tnum;

   size = 0;

   for (i=0; i<Nrow; ++i)
      for (j=0; j<Ncol; ++j)
	 cluster[i][j] = false;

 };



/******************************************************************************
 *                                                                            *
 *  Function : wolff_update()                                                 *
 *                                                                            *
 ******************************************************************************/



void wolff_update()
{
   
   void next_cycle();
   int i;
   
   set_up(); 
                         
   clearQ(&expnQ);

   cycle = 0;
   if ( pnum == source_pnum ) {
      enQ(&expnQ, source_local);
      ++size;
      spin[source_local.row][source_local.col] =
                                    - spin[source_local.row][source_local.col];
      cluster[source_local.row][source_local.col] = true;
      new_counter = 1;
    }
   else
      new_counter = 0;

   all_emptyQ = false;

   while ( !all_emptyQ ) {

      ++ cycle;
      old_counter = new_counter;
      new_counter = 0;
      next_cycle();

      all_emptyQ = emptyQ(&expnQ);
      all_emptyQ = CMMD_reduce_int(all_emptyQ, CMMD_combiner_and);
      
   };   


};



/******************************************************************************
 *                                                                            *
 *  Function : next_cycle()                                                   *
 *                                                                            *
 ******************************************************************************/


void next_cycle()
{
   void local_expansion();
   void communication();
   int i;

   clearB(&send_rB);
   clearB(&send_lB);
   clearB(&recv_rB);
   clearB(&recv_lB); 

   for (i=0; i<old_counter; ++i) 
      local_expansion();

   communication();           
                           
};
   
         

/******************************************************************************
 *                                                                            *
 *  Function : local_expansion()                                              *
 *                                                                            *
 ******************************************************************************/



void local_expansion()
{
   Cell dad, son;
   Remote_cell c;

   dad = deQ(&expnQ);    

   son.row = ( dad.row == 0 ) ? Nrow-1 : dad.row-1;
   son.col = dad.col;
   if ( ( ! cluster[son.row][son.col] ) &&
        ( -spin[dad.row][dad.col] == spin[son.row][son.col] ) &&
        ( drandom() < p ) ) {
       cluster[son.row][son.col] = true;
       spin[son.row][son.col] = - spin[son.row][son.col]; 
       enQ(&expnQ, son);
       ++size;
       ++ new_counter;
    };

   son.row = ( dad.row == Nrow-1 ) ? 0 : dad.row+1;
   son.col = dad.col;
   if ( ( ! cluster[son.row][son.col] ) &&
        ( -spin[dad.row][dad.col] == spin[son.row][son.col] ) &&
        ( drandom() < p ) ) {
       cluster[son.row][son.col] = true;
       spin[son.row][son.col] = - spin[son.row][son.col]; 
       enQ(&expnQ, son);
       ++size;
       ++ new_counter;
    };

   if ( ! lbound(dad.col) ) {  
      son.row = dad.row;
      son.col = dad.col - 1;
      if ( ( ! cluster[son.row][son.col] ) &&
           ( -spin[dad.row][dad.col] == spin[son.row][son.col] ) &&
           ( drandom() < p ) ) {
          cluster[son.row][son.col] = true;
          spin[son.row][son.col] = - spin[son.row][son.col]; 
          enQ(&expnQ, son);
          ++ size;
          ++ new_counter;
	};
    }

   else 
      if ( pnum != 0 ) {
         c.row = dad.row;
         c.col = dad.col + width - 1;
         c.spin = spin[dad.row][dad.col];
         putB(&send_lB, c);
      }
      else { 
         c.row = dad.row;
         c.col = ( dad.col > 0 ) ? dad.col - 1
	                         : Ncol-1;
         c.spin = spin[dad.row][dad.col];
         putB(&send_lB, c);
      }
      
    
   if ( ! rbound(dad.col) ) { 
      son.row = dad.row;
      son.col = dad.col + 1;
      if ( ( ! cluster[son.row][son.col] ) &&
           ( -spin[dad.row][dad.col] == spin[son.row][son.col] ) &&
           ( drandom() < p ) ) {
          cluster[son.row][son.col] = true;
          spin[son.row][son.col] = - spin[son.row][son.col]; 
          enQ(&expnQ, son);
          ++size;
          ++ new_counter;
	};
    }

   else  
      if ( pnum != nproc-1 ) {
         c.row = dad.row;
         c.col = dad.col - width + 1;
         c.spin = spin[dad.row][dad.col];
         putB(&send_rB, c);
      }
      else { 
         c.row = dad.row;
         c.col =  ( dad.col < Ncol - 1 ) ?  dad.col + 1 
                                         : 0;
         c.spin = spin[dad.row][dad.col];
         putB(&send_rB, c);
      }
     
 };





/******************************************************************************
 *                                                                            *
 *  Function : communication()                                                *
 *                                                                            *
 ******************************************************************************/


void communication()
{

   void process_recv_rB();
   void process_recv_lB();

   recv_lsize_ack = false,    
   recv_rsize_ack = false,     
   recv_lB_ack    = false,    
   recv_rB_ack    = false;    

   send_lsize = sizeB(&send_lB);
   send_lbyte = send_lsize * 3 * intsize;

   send_rsize = sizeB(&send_rB);
   send_rbyte = send_rsize * 3 * intsize;

   CMMD_sync_with_nodes();

   CMAML_rpc(lpnum, recv_rsize_handler, &recv_rsize, send_lsize);
   CMAML_rpc(rpnum, recv_lsize_handler, &recv_lsize, send_rsize);

   CMAML_poll_while_lt(&recv_rsize_ack, true);  
   CMAML_poll_while_lt(&recv_lsize_ack, true);  

   recv_rbyte = recv_rsize * 3 * intsize;
   recv_lbyte = recv_lsize * 3 * intsize;

   CMAML_set_rport_byte_counter (rport, recv_rbyte);
   CMAML_set_rport_total_nbytes (rport, recv_rbyte);

   CMAML_set_rport_byte_counter  (lport, recv_lbyte);
   CMAML_set_rport_total_nbytes  (lport, recv_lbyte);

   CMMD_sync_with_nodes();

   if ( send_lsize > 0 )  {
      CMAML_scopy(lpnum,
	          rport,
	          0,
	          0,
	          send_lB.data,
	          send_lbyte,
	          null, 
	          null);  
   };                

   if ( send_rsize > 0 )     {
      CMAML_scopy(rpnum,
	          lport,
	          0,
	          0,
	          send_rB.data,
	          send_rbyte,
	          null,
	          null);        
   };

   if ( recv_rsize > 0 )  {
      CMAML_poll_while_lt(&recv_rB_ack, true); 
      process_recv_rB();
    }

   if ( recv_lsize >  0 ) {
      CMAML_poll_while_lt(&recv_lB_ack, true);  
      process_recv_rB();
    }
};




/******************************************************************************
 *                                                                            *
 *  MAIN PROGRAM                                                              *
 *                                                                            *
 ******************************************************************************/





main(argc, argv)
     int argc;
      char *argv[];
{
   int i, j;

   double time, max, min, aver;
   double persite_time, scale_time;
   double total_sweeps;

   CMMD_disable_safety();

   initialize();

   for (i=0; i<therm_sweeps; ++i)  
      wolff_update();

   CMMD_node_timer_clear(0);
   CMMD_sync_with_nodes();

   for (j=0; j<measurements; ++j) {

      for (i=0; i<sweeps; ++i) {
         CMMD_node_timer_start(0);
 
         wolff_update();

         CMMD_node_timer_stop(0);

         /* Size */
         size        = CMMD_reduce_int(size, CMMD_combiner_add);
         sum_size   += (double)size;
         sum_sizesq += (double)(size * size);
       }

      measure();
    }

   output_of_measure();

   time = CMMD_node_timer_busy(0);

   max  = CMMD_reduce_double(time, CMMD_combiner_dmax);
   min  = CMMD_reduce_double(time, CMMD_combiner_dmin);
   aver = CMMD_reduce_double(time, CMMD_combiner_dadd) / nproc;

   CMMD_fset_io_mode(stdout, CMMD_sync_bc);
   printf("\n\n=================================================");
   printf("\n      Global Timing Data(Sweeps=%d, Width=%d)", 
                            sweeps*measurements, width);
   printf("\n=================================================\n\n");
   printf(" Max   Time = %.5f sec\n", max);
   printf(" Min   Time = %.5f sec\n", min);
   printf(" Aver. Time = %.5f sec\n", aver);
   printf("\n=================================================\n");

   total_sweeps = (double)(sweeps*measurements) / 1000.;
   time        /= total_sweeps;
   persite_time = time / sum_size;
   scale_time   = (time/sum_size) * (double)(N*N);

   printf("\n\n*************************************************");
   printf("\n           Timing Data for One Sweep");
   printf("\n*************************************************\n\n");
   printf(" Sweep Time    = %10.3f msec\n",  time );
   printf(" Time per site = %10.3f msec\n",  persite_time );
   printf(" Scale Time    = %10.3f msec\n",  scale_time );
   printf("\n*************************************************\n\n\n");   
  
};


